Skip to main content

Dijkstra's algorithm - Part 2 - Tutorial


For Part 2 of the series, we'll be developing a Priority Queue implemented using a Heap . Continuing from Part 1, we'll be using Python for the implementation.

Fortunately, Python has a PriorityQueue class in the `queue` module. It's more than enough for our purposes, but the Queue module was designed thread safe, so there is a small overhead that comes with it. The Priority Queue is a Minimum Priority Queue by default, it takes in tuples which are compared together to determine their position in the queue. For those unfamiliar with tuple comparison in Python, it works something like this.

>>> (1,2) < (3,4)
True
>>> (1,2) < (1,3)
True
>>> (1,2) < (1,1)
False
>>> (1,2) < (1,2,3)
True
>>> (1,2,3,4) < (1,2,3)
False

The first non equal element  of the both tuples determine the output of the comparison operation. So say you have a bunch of Tasks Ti with Priorities Pi, then we push (Pi, Ti) into the queue, the Queue will automatically order it such that the first element popped will be the one with the lowest priority value.

Here's an example showing this in Action.
import random,Queue
pq = Queue.PriorityQueue()
for q in range(10):
p = random.randint(0,100)
print "Inserting %d with priority %d" % (q,p)
pq.put((p,q))
while not pq.empty():
print pq.get()
raw_input()
view raw PriorityQueue hosted with ❤ by GitHub
Now, what if we wanted the priority queue to work in the reverse order (ie, Largest Value has the higher Priority)? Well, there isn't any feature provided for this by the module, but we can do a clever little hack, observe when we negate the priority the output of the comparison operation flips. Therefore, For a Maximum Priority Queue, simply insert (- Pi, Ti)....and presto, now the elements are ordered by decreasing order of priority.

For the sake of learning, we'll implement our own Priority Queue. Using a heap for a backend implementation. Python comes with the heapq module. The heapq module lets us use a list as a heap, it has the heappush and heappop functions push an element onto a heap. The comparison of the elements work as  before with the Priority Queue.

Here's the class I wrote, it has a priority-tie-breaking mechanism. I simply add a counter as the second element to the tuple, this is essential for two things. One, when two elements have the same priority, the one inserted first will be popped first. Second, if we don't add this, then we'll have to make the data-elements comparable otherwise python will attempt to compare 2 elements (possibly non-comparable) with 2 equal priorities. In order to avoid this, we introduce the counter. So the Tuple Comparison will be resolved at the counter itself. Also, I've abstracted the min/max priority by having the pqueue class take care of negating the priorities. Far more convenient in my opinion.

import heapq as hp
class pqueue:
def __init__(self, minheap = True):
self.heap = []
self.mul = 1 if minheap else -1
self.count = 0
def size(self):
return len(self.heap)
def push(self,item):
if item and isinstance(item, tuple) and isinstance(item[0],int):
self.count = self.count + 1
hp.heappush(self.heap,(item[0] * self.mul,self.count) + item[1:])
else:
raise Exception("parameter has to be a tuple with the first entry as an integer.")
def pop(self):
if self.empty(): raise Exception("pqueue is empty.")
item = hp.heappop(self.heap)
return (self.mul * item[0],) + item[2:]
def __str__(self):
return str(list((self.mul * p, r) for p,q,r in self.heap))
def __repr__(self):
return str(list((self.mul * p, r) for p,q,r in self.heap))
def empty(self):
return len(self.heap) == 0
def clear(self):
self.heap = []
view raw pqueue hosted with ❤ by GitHub
Here's the complete source code.

We now have the essential tools for implementing our Dijkstra's Shortest Path algorithm. Until next time...

Comments

Popular posts from this blog

Find Increasing Triplet Subsequence - Medium

Problem - Given an integer array A[1..n], find an instance of i,j,k where 0 < i < j < k <= n and A[i] < A[j] < A[k]. Let's start with the obvious solution, bruteforce every three element combination until we find a solution. Let's try to reduce this by searching left and right for each element, we search left for an element smaller than the current one, towards the right an element greater than the current one. When we find an element that has both such elements, we found the solution. The complexity of this solution is O(n^2). To reduce this even further, One can simply apply the longest increasing subsequence algorithm and break when we get an LIS of length 3. But the best algorithm that can find an LIS is O(nlogn) with O( n ) space . An O(nlogn) algorithm seems like an overkill! Can this be done in linear time? The Algorithm: We iterate over the array and keep track of two things. The minimum value iterated over (min) The minimum increa...

Dijkstra's algorithm - Part 1 - Tutorial

This will be a 3 Part series of posts where I will be implementing the Dijkstra's Shortest Path algorithm in Python. The three parts will be 1) Representing the Graph 2) Priority Queue 3) The Algorithm To represent a graph we'll be using an  Adjacency List . Another alternative is using an Adjacency Matrix, but for a sparse graph an Adjacency List is more efficient. Adjacency List An Adjacency List is usually represented as a HashTable (or an Array) where an entry at `u` contains a Linked List. The Linked List contains `v` and optionally another parameter `w`. Here `u` and `v` are node(or vertex) labels and `w` is the weight of the edge. By Traversing the linked list we obtain the immediate neighbours of `u`. Visually, it looks like this. For implementing this in Python, we'll be using the dict()  for the main HashTable. For the Linked List we can use a list of 2 sized tuples (v,w).  Sidenote: Instead of a list of tuples, you can use a dict(), ...

Find the Quadruplets - Hard

Problem - Given 4 arrays A,B,C,D. Find out if there exists an instance where A[i] + B[j] + C[k] + D[l] = 0 Like the Find the Triple problem, we're going to develop 4 algorithms to solve this. Starting with the naive O(n^4) solution. Then we proceed to eliminate the inner-most loop with a Binary Search, reducing the complexity to O(n^3 logn) Now, we replace the last 2 loops with the left-right traversal we did in the previous 3 posts. Now the complexity is O(n^3). Finally, we reduce the complexity to O(n^2 logn) at the cost of O(n^2) Space Complexity. We store every combination of A[i] + B[j] and store it in AB[]. Similarly we make CD[] out of C[i] + D[j]. So, AB = A x B CD = C x D We then sort AB and CD (which costs O(n^2 log(n^2)) ~ O(n^2 logn) ) and then run a left-right linear Algorithm on AB and CD. (Note : Their size is of the order O(n^2)) So the overall complexity is due to sorting the large array of size n^2. which is O(n^2 logn).